#include <stdio.h>

#define NUM_CARTAS 64
#define CARTAS_POR_LINHA 8

unsigned int randaux() {
    static long seed = 1;
    return (((seed = seed * 214013L + 2531011L) >> 16) & 0x7fff);
}

void Baralhar(int v[], int n) {
    int i, j, aux;
    // processar todos os elementos
    for (i = 0; i < n - 1; i++) {
        // gerar um valor aleatório para sortear o elemento do vector a ficar na posição i (entre i e n-1)
        j = i + randaux() % (n - i);
        aux = v[i];
        v[i] = v[j];
        v[j] = aux;
    }
}

void main() {
    int desperdicio, i;
    scanf("%d", &desperdicio);
    
    for(i=0; i<desperdicio; i++)
        randaux();
 
    char operacoes[] = {'+', '-', '*', '/'};
    char numeros[] = {'1', '2', '3', '4'};
    char letras[] = {'A', 'B', 'C', 'D'};

    int ordem[NUM_CARTAS];

    // Preencher a ordem original
    for (int i = 0; i < NUM_CARTAS; i++) {
        ordem[i] = i;
    }

    // Embaralhar a ordem utilizando a função Baralhar
    Baralhar(ordem, NUM_CARTAS);

    // Imprimir as 64 cartas possíveis por ordem de coluna
    printf("    [1] [2] [3] [4] [5] [6] [7] [8]\n");
    for (int i = 0; i < CARTAS_POR_LINHA; i++) {
        printf("[%d]", i + 1);
        for (int j = 0; j < NUM_CARTAS / CARTAS_POR_LINHA; j++) {
            int numeroJogador = ordem[i + j * CARTAS_POR_LINHA];
            int k = numeroJogador / 16;
            int l = (numeroJogador % 16) / 4;
            int m = numeroJogador % 4;
            printf(" %c%c%c", operacoes[k], numeros[l], letras[m]);
        }
        printf("\n");
    }
}
