#include <stdio.h>

#define NUM_CARTAS 64
#define CARTAS_POR_LINHA 8
#define MASCARA "###"

unsigned int randaux() {
    static long seed = 1;
    return (((seed = seed * 214013L + 2531011L) >> 16) & 0x7fff);
}

void Baralhar(int v[], int n) {
    int i, j, aux;
    // processar todos os elementos 
    for (i = 0; i < n - 1; i++) {
        // gerar um valor aleatório para sortear o elemento do vector a ficar na posição i (entre i e n-1)
        j = i + randaux() % (n - i);
        aux = v[i];
        v[i] = v[j];
        v[j] = aux;
    }
}

void main() {
    int desperdicio, i;
     scanf("%d", &desperdicio);
     for(i=0; i<desperdicio; i++)
     randaux();
     
    char operacoes[] = {'+', '-', '*', '/'};
    char numeros[] = {'1', '2', '3', '4'};
    char letras[] = {'A', 'B', 'C', 'D'};

    int ordem[NUM_CARTAS];

    // Preencher a ordem original
    for (int i = 0; i < NUM_CARTAS; i++) {
        ordem[i] = i;
    }

    // Embaralhar a ordem utilizando a função Baralhar
    Baralhar(ordem, NUM_CARTAS);

    // Pedir ao usuário para digitar 4 números inteiros correspondentes a posições na matriz
    int posicoes[4];
    for (int i = 0; i < 4; i++) {
        scanf("%d", &posicoes[i]);
    }
    
    int trava = 0;
    for (int i = 0; i < 4; i++) {
        if(trava == 0 && (posicoes[i] < 11 || posicoes[i] > 88)) {
            trava = 1;
        }
        if(trava == 1) {
            posicoes[i] = 0;
        }
    }
    
    // Imprimir as 64 cartas possíveis por ordem de coluna
    printf("    [1] [2] [3] [4] [5] [6] [7] [8]\n");
    for (int i = 1; i <= CARTAS_POR_LINHA; i++) {
        printf("[%d]", i);
        for (int j = 1; j <= NUM_CARTAS / CARTAS_POR_LINHA; j++) {
            int numeroJogador = ordem[(j - 1) * CARTAS_POR_LINHA + (i - 1)];
            int k = numeroJogador / 16;
            int l = (numeroJogador % 16) / 4;
            int m = numeroJogador % 4;

            // Calcular a posição atual na matriz
            int posicaoAtual = j * 10 + i;

            // Verificar se a posição atual está nas posições especificadas pelo usuário
            int revelar = 0;
            for (int n = 0; n < 4; n++) {
                if (posicaoAtual == posicoes[n]) {
                    revelar = 1;
                    break;
                }
            }

            if (revelar) {
                printf(" %c%c%c", operacoes[k], numeros[l], letras[m]);
            } else {
                printf(" " MASCARA);
            }
        }
        printf("\n");
    }
}