#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//////////////
// alnea A //
//////////////
int CartaLetra(int carta) {
    return carta % 4;
}
int CartaNumero(int carta) {
    return (carta / 4) % 4;
}
int CartaOperador(int carta) {
    return (carta / 16) % 4;
}
void MostraCarta(int carta) {
    static const char operadores[] = "+-*/";
    printf("%c%c%c",
        operadores[CartaOperador(carta)],
        '1' + CartaNumero(carta),
        'A' + CartaLetra(carta));
}

//////////////
// alnea B //
//////////////
unsigned int randaux()
{
    static long seed = 1;
    return(((seed = seed * 214013L + 2531011L) >> 16) & 0x7fff);
}
void Baralhar(int v[], int n)
{
    int i, j, aux;
    for (i = 0; i < n - 1; i++)
    {
        j = i + randaux() % (n - i);
        aux = v[i];
        v[i] = v[j];
        v[j] = aux;
    }
}

//////////////
// alnea C //
//////////////
int Find(int v[], int n, int elemento)
{
    int i;
    for (i = 0; i < n; i++)
        if (v[i] == elemento)
            return i;
    return -1;
}
int PosicaoValida(int posicao) {
    return !(posicao / 10 > 8 || posicao / 10 < 1 || posicao % 10 > 8 || posicao % 10 < 1);
}
int LerJogada(int jogada[4]) {
    char str[256], * pt;
    int nposicoes = 0;
    //printf("\nIntroduzir jogada: ");
    fgets(str, 256, stdin);
    pt = strtok(str, " ");
    while (pt != NULL &&
        nposicoes < 4 &&
        PosicaoValida(jogada[nposicoes] = atoi(pt)))
    {
        nposicoes++;
        pt = strtok(NULL, " ");
    }
    return nposicoes;
}

//////////////
// alnea D //
//////////////

/* void MostraBaralho(int* baralho, int* posicoes, int nposicoes, int remove, int visualizar); // alterado da alnea anterior
- remove: se verdade, remove as cartas do baralho, aps mostr-las (cdigo de valor -1)
- visualizar: se falso, no mostra as cartas, mas remove as carts se for caso disso
- a visualizao apenas mostra ### se a carta existir, se tiver sido removida (valor -1), mostrar "   "
*/
void MostraBaralho(int* baralho, int* posicoes, int nposicoes, int remove, int visualizar)
{
    int linha, coluna;
    if (!visualizar) { // no visualiza, apenas remove as cartas
        if (remove)
            for (linha = 1; linha <= 8; linha++)
                for (coluna = 1; coluna <= 8; coluna++)
                    if (Find(posicoes, nposicoes, coluna * 10 + linha) >= 0)
                        baralho[(coluna - 1) * 8 + linha - 1] = -1; // cdigo -1, carta removida
    }
    else {
        printf("\n    ");
        for (coluna = 1; coluna <= 8; coluna++)
            printf("[%d] ", coluna);
        for (linha = 1; linha <= 8; linha++) {
            printf("\n[%d] ", linha);
            for (coluna = 1; coluna <= 8; coluna++) {
                if (Find(posicoes, nposicoes, coluna * 10 + linha) >= 0) {
                    MostraCarta(baralho[(coluna - 1) * 8 + linha - 1]);
                    // teste de remoo, se verdade, fica com cdigo -1 de carta removida
                    if (remove)
                        baralho[(coluna - 1) * 8 + linha - 1] = -1;
                }
                else if (baralho[(coluna - 1) * 8 + linha - 1] >= 0) // cdigo vlido
                    printf("###");
                else // cdigo de carta removida
                    printf("   ");
                printf(" ");
            }
        }
    }
}

// int CartasEmparelham(int* baralho, int* posicoes, int nposicoes);
// - caso as posies fornecidas tenham cartas que emparelhem, retornar verdadeiro
// - verificar se tm o mesmo operador/nmero/letra
// - guardar um nmero para cada tipo, colocando com o valor da primeira carta
//   - assim que seja distinto, inativar o nmero colocando a -1
// - se existir um que no tenha sido inativado, as cartas emparelham, c.c. no
int CartasEmparelham(int* baralho, int* posicoes, int nposicoes) {
    int i, carta;
    int operador = -1, numero = -1, letra = -1;
    // verificar se as cartas tm o mesmo operador/nmero/naipe
    for (i = 0; i < nposicoes; i++) {
        if ((carta = baralho[(posicoes[i] / 10 - 1) * 8 + posicoes[i] % 10 - 1]) < 0)
            return -1; // carta removida, perdeu j
        if (i == 0) { // um destes valores tem de permanecer igual, para emparalhar
            operador = CartaOperador(carta);
            numero = CartaNumero(carta);
            letra = CartaLetra(carta);
        }
        else {
            if (operador != CartaOperador(carta))
                operador = -1;
            if (numero != CartaNumero(carta))
                numero = -1;
            if (letra != CartaLetra(carta))
                letra = -1;
        }
    }
    return operador >= 0 || numero >= 0 || letra >= 0;
}

// int NumeroCartas(int* baralho); // retorna o nmero de cartas no removidas (cdigo negativo)
int NumeroCartas(int* baralho)
{
    int i, resultado = 0;
    for (i = 0; i < 64; i++)
        if (baralho[i] >= 0)
            resultado++;
    return resultado;
}

// int JogadaAutomatica(int* baralho, int jogada[]);
// - executa uma jogada automtica, retornando o nmero de posies vlidas
// - localizar o primeiro elemento do baralho no removido
// - a jogada  constituda por uma s posio, tendo-se que indicar a posio correspondente ao ndice da carta
int JogadaAutomatica(int* baralho, int jogada[])
{
    int i;
    for (i = 0; i < 64; i++)
        if (baralho[i] >= 0) {
            jogada[0] = (1 + i / 8) * 10 + (i % 8) + 1;
            return 1;
        }
    return 0;
}

/* void JogarMemoria(int* baralho); // jogo da memria, com o baralho fornecido
Estrutura de dados:
int njogada; // contm o nmero de jogadas
int emparelha; // resultado da funo de teste 0/1 se as cartas emparelharem, se negativo o jogo deve terminar
int nposicoes; // nmero de posies lidas corretamente na jogada, entre 0 e 4
int utilizadorOK; // 1 se leitura de jogada OK da parte do utilizador, c.c. ficar a 0, passando-se a utilizar a jogada automtica
Funcionamento global:
- mostrar a posio inicial
- ciclo enquanto existirem cartas no baralho
- incrementar a jogada, e ler do utilizador novas posies enquanto existirem dados
- aps 0 posies lidas do utilizador, passar a fazer a jogada automtica
- Atualizar a varivel de emparelhamento, para a jogada atual lida. Se o valor for negativo, ento o jogo termina, foi selecionada uma carta removida
- mostrar o baralho, removendo as cartas se emparelharem na ltima jogada. Visualizar apenas nas primeiras 5 jogadas
- retorna sempre o nmero da jogada atual
*/
int JogarMemoria(int* baralho)
{
    int jogada[4], nposicoes = 0, emparelha = 0;
    int njogada = 0, utilizadorOK = 1;
    MostraBaralho(baralho, NULL, 0, 0, 1);
    while (NumeroCartas(baralho) > 0) {
        njogada++;
        if (utilizadorOK)
            utilizadorOK = ((nposicoes = LerJogada(jogada)) > 0);
        if (!utilizadorOK)
            nposicoes = JogadaAutomatica(baralho, jogada);
        if ((emparelha = CartasEmparelham(baralho, jogada, nposicoes)) < 0)
            return njogada; // se negativo, jogada invlida, acabou o jogo
        MostraBaralho(baralho, jogada, nposicoes, emparelha, njogada < 5);
    }
    return njogada;
}

/*
Estrutura de dados:
int njogada; // contm o nmero de jogadas
Funcionamento global:
- Tal como na alnea C:
  - Solicitar desperdcio e chamar randaux() tantas vezes quantas o valor de desperdcio;
  - Inicializar baralho com os cdigos por ordem sequencial;
  - Baralhar o baralho.
- Jogar ao jogo da memria, registando o nmero de jogadas
- Mostrar o baralho final, e imprimir mensagem final com o nmero de jogadas e cartas finais
*/
void main()
{
    int njogada;
    int baralho[64];
    int desperdicio, i;
    scanf("%d\n", &desperdicio);
    for (i = 0; i < desperdicio; i++)
        randaux();
    for (i = 0; i < 64; i++)
        baralho[i] = i;
    Baralhar(baralho, 64);
    njogada = JogarMemoria(baralho);
    MostraBaralho(baralho, NULL, 0, 0, 1);
    printf("\nJogo com %d jogadas. Restam %d cartas.", njogada, NumeroCartas(baralho));
}


//////////////////
// Alternativas //
//////////////////

// int CartasEmparelham1(int* baralho, int* posicoes, int nposicoes);
// - contar o nmero de cartas iguais  primeira, em vez de detectar diferentes
// - as cartas emparelham se um dos tipos for igual ao nmero de cartas
// - no efetuar atribuies em condicionais, ter sempre um operador no condicional
int CartasEmparelham1(int* baralho, int* posicoes, int nposicoes) {
    int i, carta, cartaInicial;
    int operador = 0, numero = 0, letra = 0;
    cartaInicial = baralho[(posicoes[0] / 10 - 1) * 8 + posicoes[0] % 10 - 1];
    // verificar se as cartas tm o mesmo operador/nmero/naipe
    for (i = 0; i < nposicoes; i++) {
        carta = baralho[(posicoes[i] / 10 - 1) * 8 + posicoes[i] % 10 - 1];
        if (carta < 0)
            return -1; // carta removida, perdeu j
        if (CartaOperador(cartaInicial) == CartaOperador(carta))
            operador++;
        if (CartaNumero(cartaInicial) == CartaNumero(carta))
            numero++;
        if (CartaLetra(cartaInicial) == CartaLetra(carta))
            letra++;
    }
    return operador == nposicoes || numero == nposicoes || letra == nposicoes;
}
// int JogarMemoria1(int* baralho);
// - no efetuar atribuies em condicionais, ter sempre um operador no condicional
int JogarMemoria1(int* baralho)
{
    int jogada[4], nposicoes = 0, emparelha = 0;
    int njogada = 0, utilizadorOK = 1;
    MostraBaralho(baralho, NULL, 0, 0, 1);
    while (NumeroCartas(baralho) > 0) {
        njogada++;
        if (utilizadorOK == 1) {
            nposicoes = LerJogada(jogada);
            if (nposicoes <= 0)
                utilizadorOK = 0;
        }
        if (utilizadorOK == 0)
            nposicoes = JogadaAutomatica(baralho, jogada);
        emparelha = CartasEmparelham(baralho, jogada, nposicoes);
        if (emparelha < 0)
            return njogada; // se negativo, jogada invlida, acabou o jogo
        MostraBaralho(baralho, jogada, nposicoes, emparelha, njogada < 5);
    }
    return njogada;
}
// - Como vantagem o cdigo de ambas as funes tem uma leitura mais natural.
//   Em modo de debug, temos mais informao da linha, podendo separar melhor as funes.
//   A contagem de marcas iguais, pode ser considerada mais clara que a deteo de diferenas.
// - A desvantagem poder ser o cdigo mais extenso devido a repetio de variveis, 
//   sendo considerado por algumas pessoas, a verso mais curta como sendo cdigo mais elegante. 
//   Em termos de eficincia, dificilmente se registam diferenas.

/* void MostraBaralho2(int* baralho, int* posicoes, int nposicoes);
- visualizar sempre, nunca remover cartas, fazer uma funo para esse efeito
*/
void MostraBaralho2(int* baralho, int* posicoes, int nposicoes)
{
    int linha, coluna;
    printf("\n    ");
    for (coluna = 1; coluna <= 8; coluna++)
        printf("[%d] ", coluna);
    for (linha = 1; linha <= 8; linha++) {
        printf("\n[%d] ", linha);
        for (coluna = 1; coluna <= 8; coluna++) {
            if (Find(posicoes, nposicoes, coluna * 10 + linha) >= 0)
                MostraCarta(baralho[(coluna - 1) * 8 + linha - 1]);
            else if (baralho[(coluna - 1) * 8 + linha - 1] >= 0) // cdigo vlido
                printf("###");
            else // cdigo de carta removida
                printf("   ");
            printf(" ");
        }
    }
}
/* void RemoveBaralho2b(int* baralho, int* posicoes, int nposicoes);
- remove as cartas por acesso  posio diretamente, em vez de iterar pelas posies
*/
void RemoveBaralho2(int* baralho, int* posicoes, int nposicoes)
{
    int i;
    for (i = 0; i < nposicoes; i++)
        baralho[(posicoes[i] / 10 - 1) * 8 + posicoes[i] % 10 - 1] = -1;
}
/* int JogarMemoria2(int* baralho);
- chama as funes de modo distinto, primeiro mostra nas primeiras jogadas
- aps mostrar, se as cartas emparelharam, ento apaga-as
*/
int JogarMemoria2(int* baralho)
{
    int jogada[4], nposicoes = 0, emparelha = 0;
    int njogada = 0, utilizadorOK = 1;
    MostraBaralho2(baralho, NULL, 0);
    while (NumeroCartas(baralho) > 0) {
        njogada++;
        if (utilizadorOK)
            utilizadorOK = ((nposicoes = LerJogada(jogada)) > 0);
        if (!utilizadorOK)
            nposicoes = JogadaAutomatica(baralho, jogada);
        if ((emparelha = CartasEmparelham(baralho, jogada, nposicoes)) < 0)
            return njogada; // se negativo, jogada invlida, acabou o jogo
        if (njogada < 5)
            MostraBaralho2(baralho, jogada, nposicoes);
        if (emparelha)
            RemoveBaralho2(baralho, jogada, nposicoes);
    }
    return njogada;
}
// - Como vantagens tem a utilizao de menos argumentos em vrias funes.
//   O algoritmo de remover cartas  mais rpido.
// - A desvantagem  a necessidade de duas passagens, uma para mostrar e outra para remover.

